package ch.unige.aou.controller.access;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.security.UserPermissions;

import ch.unige.aou.controller.AccessController;
import ch.unige.aou.model.settings.DownloadToken;
import ch.unige.aou.rest.UrlPath;
import ch.unige.aou.service.DownloadTokenService;

@UserPermissions
@RestController
@ConditionalOnBean(AccessController.class)
@RequestMapping(UrlPath.ACCESS_DOWNLOAD_TOKEN)
public class AccessDownloadTokenController {

  private final DownloadTokenService downloadTokenService;

  public AccessDownloadTokenController(DownloadTokenService downloadTokenService) {
    this.downloadTokenService = downloadTokenService;
  }

  @GetMapping("/{archiveId}")
  public ResponseEntity<DownloadToken> getToken(@PathVariable String archiveId) {
    return new ResponseEntity<>(this.downloadTokenService.getHeadersWithToken(archiveId), HttpStatus.OK);
  }

}
