package ch.unige.aou.controller.access;

import java.util.List;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.http.HttpEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.security.EveryonePermissions;

import ch.unige.aou.controller.AccessController;
import ch.unige.aou.model.search.AdvancedSearchCriteria;
import ch.unige.aou.rest.AouActionName;
import ch.unige.aou.rest.UrlPath;
import ch.unige.aou.service.SettingsService;

@RestController
@EveryonePermissions
@ConditionalOnBean(AccessController.class)
@RequestMapping(UrlPath.ACCESS_SETTINGS)
public class AccessSettingsController {

  private SettingsService settingsService;

  public AccessSettingsController(SettingsService settingsService) {
    this.settingsService = settingsService;
  }

  @GetMapping(value = "/" + AouActionName.LIST_ADVANCED_SEARCH_CRITERIA)
  public HttpEntity<List<AdvancedSearchCriteria>> listAdvancedSearchCriteria() {
    return new HttpEntity<>(this.settingsService.getAdvancedSearchCriteriaList());
  }
}
