package ch.unige.aou.business;

import java.util.Optional;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.stereotype.Service;

import ch.unige.aou.AouConstants;
import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.Sortable;
import ch.unige.aou.model.security.Role;
import ch.unige.aou.model.settings.Label;
import ch.unige.aou.repository.RoleRepository;
import ch.unige.aou.specification.RoleSpecification;

@Service
@ConditionalOnBean(AdminController.class)
public class RoleService extends AouResourceService<Role> {
  private static final Logger log = LoggerFactory.getLogger(RoleService.class);

  private RoleRepository roleRepository;
  private LabeledLanguageService labeledLanguageService;

  public RoleService(RoleRepository roleRepository, LabeledLanguageService labeledLanguageService) {
    this.roleRepository = roleRepository;
    this.labeledLanguageService = labeledLanguageService;
  }

  @Override
  public RoleSpecification getSpecification(Role resource) {
    return new RoleSpecification(resource);
  }

  @Override
  public Optional<Integer> getMaxSortValue(Sortable item) {
    return ((RoleRepository) this.itemRepository).findMaxSortValue();
  }

  @Override
  protected void beforeValidate(Role item) {
    this.setDefaultSortValue(item);
  }

  public void initDefaultData() {
  }
}
