package ch.unige.aou.controller.admin;

import java.util.List;
import java.util.Map;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.data.domain.Pageable;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.controller.ResourceController;
import ch.unige.solidify.rest.RestCollection;
import ch.unige.solidify.security.EveryonePermissions;
import ch.unige.solidify.security.UserPermissions;

import ch.unige.aou.business.ContributorRoleService;
import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.publication.ContributorRole;
import ch.unige.aou.model.publication.PublicationSubtypeContributorRoleDTO;
import ch.unige.aou.rest.AouActionName;
import ch.unige.aou.rest.UrlPath;

@UserPermissions
@RestController
@ConditionalOnBean(AdminController.class)
@RequestMapping(UrlPath.ADMIN_CONTRIBUTOR_ROLE)
public class ContributorRoleController extends ResourceController<ContributorRole> {

  @Override
  public HttpEntity<RestCollection<ContributorRole>> list(ContributorRole search, Pageable pageable) {
    return super.list(search, pageable);
  }

  @EveryonePermissions
  @GetMapping(AouActionName.LIST_CONTRIBUTOR_ROLES)
  public HttpEntity<Map<String, List<PublicationSubtypeContributorRoleDTO>>> listContributorRoles() {
    return new ResponseEntity<>(((ContributorRoleService)this.itemService).listContributorRoleByPublicationSubType(), HttpStatus.OK);
  }
}
