package ch.unige.aou.controller.admin;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.controller.ResourceReadOnlyController;
import ch.unige.solidify.security.TrustedUserPermissions;

import ch.unige.aou.business.DocumentFileService;
import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.publication.DocumentFile;
import ch.unige.aou.rest.AouActionName;
import ch.unige.aou.rest.UrlPath;

@TrustedUserPermissions
@RestController
@ConditionalOnBean(AdminController.class)
@RequestMapping(UrlPath.ADMIN_DOCUMENT_FILES)
public class DocumentFileController extends ResourceReadOnlyController<DocumentFile> {

  @GetMapping(SolidifyConstants.URL_ID_PLUS_SEP + AouActionName.FULLTEXT)
  @ResponseBody
  public String fulltext(@PathVariable String id) {
    DocumentFile documentFile = this.itemService.findOne(id);
    return ((DocumentFileService) this.itemService).getFulltext(documentFile);
  }
}
