package ch.unige.aou.controller.admin;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.security.AdminPermissions;
import ch.unige.solidify.security.EveryonePermissions;

import ch.unige.aou.AouConstants;
import ch.unige.aou.business.PublicationTypeService;
import ch.unige.aou.controller.AdminController;
import ch.unige.aou.rest.AouActionName;

@AdminPermissions
@RestController
@ConditionalOnBean(AdminController.class)
@RequestMapping(ch.unige.aou.rest.UrlPath.ADMIN_MONITOR)
public class MonitorController {

  private PublicationTypeService publicationTypeService;

  public MonitorController(PublicationTypeService publicationTypeService) {
    this.publicationTypeService = publicationTypeService;
  }

  @GetMapping(AouActionName.MONITOR_DATABASE_CONNECTION)
  @EveryonePermissions
  public HttpStatus testDatabaseConnection() {
    this.publicationTypeService.existsById(AouConstants.DEPOSIT_TYPE_ARTICLE_ID);
    return HttpStatus.OK;
  }
}
