package ch.unige.aou.controller.admin;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.data.domain.Pageable;
import org.springframework.http.HttpEntity;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.controller.CompositionController;
import ch.unige.solidify.rest.RestCollection;
import ch.unige.solidify.security.AdminPermissions;
import ch.unige.solidify.security.UserPermissions;

import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.publication.PublicationSubSubtype;
import ch.unige.aou.model.publication.PublicationSubtype;
import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.rest.UrlPath;

@AdminPermissions
@RestController
@ConditionalOnBean(AdminController.class)
@RequestMapping(UrlPath.ADMIN_PUBLICATION_SUBTYPES + SolidifyConstants.URL_PARENT_ID + ResourceName.PUBLICATION_SUB_SUBTYPES)
public class PublicationSubSubtypeController extends CompositionController<PublicationSubtype, PublicationSubSubtype> {

  @Override
  @UserPermissions
  public HttpEntity<RestCollection<PublicationSubSubtype>> list(@PathVariable String parentid, @ModelAttribute PublicationSubSubtype filterItem,
          Pageable pageable) {
    return super.list(parentid, filterItem, pageable);
  }

  @Override
  @UserPermissions
  public HttpEntity<PublicationSubSubtype> get(@PathVariable String parentid, @PathVariable String id) {
    return super.get(parentid, id);
  }

  @Override
  protected PublicationSubtype getParentResourceProperty(PublicationSubSubtype subResource) {
    return subResource.getPublicationSubtype();
  }

  @Override
  protected void setParentResourceProperty(PublicationSubSubtype subResource, PublicationSubtype parentResource) {
    subResource.setPublicationSubtype(parentResource);
  }
}
