package ch.unige.aou.controller.admin;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.data.domain.Pageable;
import org.springframework.http.HttpEntity;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.controller.CompositionController;
import ch.unige.solidify.rest.RestCollection;
import ch.unige.solidify.security.AdminPermissions;
import ch.unige.solidify.security.UserPermissions;

import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.publication.PublicationSubtype;
import ch.unige.aou.model.publication.PublicationType;
import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.rest.UrlPath;

@AdminPermissions
@RestController
@ConditionalOnBean(AdminController.class)
@RequestMapping(UrlPath.ADMIN_PUBLICATION_TYPES + SolidifyConstants.URL_PARENT_ID + ResourceName.PUBLICATION_SUBTYPES)
public class PublicationSubtypeCompositionController extends CompositionController<PublicationType, PublicationSubtype> {

  @Override
  @UserPermissions
  public HttpEntity<RestCollection<PublicationSubtype>> list(@PathVariable String parentid, @ModelAttribute PublicationSubtype filterItem,
          Pageable pageable) {
    return super.list(parentid, filterItem, pageable);
  }

  @Override
  @UserPermissions
  public HttpEntity<PublicationSubtype> get(@PathVariable String parentid, @PathVariable String id) {
    return super.get(parentid, id);
  }

  @Override
  protected PublicationType getParentResourceProperty(PublicationSubtype publicationSubtype) {
    return publicationSubtype.getPublicationType();
  }

  @Override
  protected void setParentResourceProperty(PublicationSubtype publicationSubtype, PublicationType publicationType) {
    publicationSubtype.setPublicationType(publicationType);
  }
}
