package ch.unige.aou.repository;

import java.util.List;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import ch.unige.solidify.repository.SolidifyRepository;

import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.publication.Comment;

@Repository
@SuppressWarnings("squid:S1214")
@ConditionalOnBean(AdminController.class)
public interface CommentRepository extends SolidifyRepository<Comment> {

  @Query("SELECT c FROM Comment c WHERE c.publication.resId = :publicationId")
  List<Comment> findByPublicationId(String publicationId);

  List<Comment> findByPersonResId(String personId);
}
