package ch.unige.aou.repository;

import java.util.Optional;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.stereotype.Repository;

import ch.unige.solidify.repository.SolidifyRepository;

import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.publication.Contributor;

@Repository
@ConditionalOnBean(AdminController.class)
public interface ContributorRepository extends SolidifyRepository<Contributor> {

  Contributor findByCnIndividu(String cnIndividu);

  Contributor findByFirstNameAndLastNameAndCnIndividuIsNull(String firstname, String lastname);

  Optional<Contributor> findByResIdAndPublicationsIsNull(String resId);
}
