package ch.unige.aou.repository;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import ch.unige.solidify.repository.SolidifyRepository;

import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.settings.Institution;
import ch.unige.aou.model.settings.Person;

@Repository
@SuppressWarnings("squid:S1214")
@ConditionalOnBean(AdminController.class)
public interface InstitutionRepository extends SolidifyRepository<Institution> {
  // *************
  // ** Queries **
  // *************

  @Query("SELECT p FROM Institution i JOIN i.people p WHERE i.resId = :parentId")
  public Page<Person> findPeopleByParentId(@Param("parentId") String parentId, Pageable pageable);

  @Query("SELECT p FROM Institution i JOIN i.people p WHERE i.resId = :parentId AND p.resId=:id")
  public Person findPeopleByParentId(@Param("parentId") String parentId, @Param("id") String id);

  @Query("SELECT i FROM Institution i WHERE :emailSuffix IN i.emailSuffixes")
  public Institution findByEmailSuffix(@Param("emailSuffix") String emailSuffix);

  Institution findByName(String name);
}
