package ch.unige.aou.repository;

import java.net.URL;
import java.util.Optional;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import ch.unige.solidify.repository.SolidifyRepository;

import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.settings.License;

@Repository
@SuppressWarnings("squid:S1214")
@ConditionalOnBean(AdminController.class)
public interface LicenseRepository extends SolidifyRepository<License> {

  License findByOpenLicenseId(String openLicenseid);

  License findByTitle(String title);

  License findByUrl(URL url);

  @Query(value = "SELECT max(sortValue) FROM License")
  Optional<Integer> findMaxSortValue();
}
