package ch.unige.aou.repository;

import java.util.List;
import java.util.Optional;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import ch.unige.solidify.repository.SolidifyRepository;

import ch.unige.aou.AouMetadataVersion;
import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.publication.Publication;
import ch.unige.aou.model.settings.Person;

@Repository
@SuppressWarnings("squid:S1214")
@ConditionalOnBean(AdminController.class)
public interface PublicationRepository extends SolidifyRepository<Publication> {

  Optional<Publication> findByDoi(String doi);

  Optional<Publication> findByPmid(String pmid);

  List<Publication> findPublicationByMetadataVersionIsNot(AouMetadataVersion metadataVersion);

  boolean existsByArchiveId(String archiveId);

  List<Publication> findByCreatorResId(String creatorId);

}
