package ch.unige.aou.repository;

import java.util.Optional;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import ch.unige.solidify.repository.SolidifyRepository;

import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.publication.PublicationSubtype;

@Repository
@ConditionalOnBean(AdminController.class)
public interface PublicationSubtypeRepository extends SolidifyRepository<PublicationSubtype> {
  Optional<PublicationSubtype> findByName(String name);

  PublicationSubtype findByCode(String code);

  @Query(value = "SELECT max(pst.sortValue) FROM PublicationSubtype pst WHERE pst.publicationType.resId = :publicationTypeId")
  Optional<Integer> findMaxSortValueByPublicationType(String publicationTypeId);
}
