package ch.unige.aou.repository;

import java.util.Optional;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import ch.unige.solidify.repository.SolidifyRepository;

import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.publication.PublicationType;

@Repository
@ConditionalOnBean(AdminController.class)
public interface PublicationTypeRepository extends SolidifyRepository<PublicationType> {
  PublicationType findByName(String name);

  @Query(value = "SELECT max(sortValue) FROM PublicationType")
  Optional<Integer> findMaxSortValue();
}
