package ch.unige.aou.service;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;

import ch.unige.solidify.auth.model.UserInfo;
import ch.unige.solidify.service.UserInfoService;

import ch.unige.aou.controller.AdminController;
import ch.unige.aou.repository.UserRepository;

/**
 * Implementation of UserInfoService is not done in UserService in order to prevent a circular dependency problem
 */
@Service
@Primary
@ConditionalOnBean(AdminController.class)
public class UserProviderService implements UserInfoService {

  private UserRepository userRepository;

  public UserProviderService(UserRepository userRepository) {
    this.userRepository = userRepository;
  }

  @Override
  public UserInfo findByExternalUid(String externalUid) {
    return this.userRepository.findByExternalUid(externalUid);
  }
}
