package ch.unige.aou.service.security;

import ch.unige.solidify.util.StringTool;

import ch.unige.aou.business.PersonService;

public abstract class AbstractAdminPermissionService extends AbstractPermissionService {

  protected PersonService personService;

  public AbstractAdminPermissionService(PersonService personService) {
    this.personService = personService;
  }

  protected String getPersonAuthenticatedId() {
    return this.personService.getLinkedPersonId(this.getAuthentication());
  }

  public boolean isUserConnectedLinkedToPerson(String personId) {
    if (StringTool.isNullOrEmpty(personId)) {
      return false;
    }
    return personId.equals(this.getPersonAuthenticatedId());
  }
}
