package ch.unige.aou.task;

import java.util.List;

import ch.unige.aou.business.NotificationService;
import ch.unige.aou.business.ScheduledTaskService;
import ch.unige.aou.message.EmailMessage;
import ch.unige.aou.model.notification.Notification;
import ch.unige.aou.model.notification.NotificationType;
import ch.unige.aou.model.publication.Publication;
import ch.unige.aou.model.schedule.ScheduledTask;

public class NotifyPublicationsValidatedToContributorsTask extends TaskWithNotificationsRunnable {

  public NotifyPublicationsValidatedToContributorsTask(ScheduledTaskService scheduledTaskService, ScheduledTask scheduledTask,
          NotificationService notificationService, TaskExecutorService taskExecutorService) {
    super(scheduledTaskService, scheduledTask, notificationService, taskExecutorService);
  }

  @Override
  protected void executeTask() {
    List<Notification> notificationsToSend = this.getNotificationsToSend(NotificationType.MY_INDIRECT_PUBLICATION_VALIDATED);
    if (!notificationsToSend.isEmpty()) {
      this.taskExecutorService.getNotificationsAndSendEmails(notificationsToSend, List.of(Publication.PublicationStatus.COMPLETED),
              NotificationType.MY_INDIRECT_PUBLICATION_VALIDATED,
              EmailMessage.EmailTemplate.MY_INDIRECT_PUBLICATION_VALIDATED);
    }
  }
}
