package ch.unige.aou.test.storage;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.Mock;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.context.junit.jupiter.SpringExtension;

import ch.unige.solidify.config.SolidifyProperties;

import ch.unige.aou.business.DocumentFileService;
import ch.unige.aou.business.DocumentFileTypeService;
import ch.unige.aou.business.LicenseService;
import ch.unige.aou.config.AouProperties;
import ch.unige.aou.service.storage.FileStorageService;

@ActiveProfiles({ "storage-file", "sec-noauth" })
@ExtendWith(SpringExtension.class)
class FileStorageServiceTest extends StorageServiceTest {

  @Mock
  private LicenseService licenseService;

  @Mock
  private DocumentFileTypeService documentFileTypeService;

  @Mock
  private DocumentFileService documentFileService;

  @BeforeEach
  public void setup() {
    super.setUp();

    AouProperties aouProperties = new AouProperties(new SolidifyProperties());
    this.storageService = new FileStorageService(aouProperties, this.messageService, this.publicationService, this.userService,
            this.metadataService, documentFileTypeService, licenseService, documentFileService);
  }

  @Test
  @Disabled
  void storageTest() {
    this.runTests("faust-1072055880-aip-zip");
  }
}
