package ch.unige.aou.service.admin;

import java.util.List;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;

import ch.unige.solidify.SolidifyClientApplication;
import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.service.CompositionResourceClientService;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.model.publication.Comment;
import ch.unige.aou.model.publication.Publication;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;

@Service
public class CommentClientService extends CompositionResourceClientService<Publication, Comment> {
  private static final String COMMENT_PATH = SolidifyConstants.URL_SEP + ResourceName.PUBLICATIONS + SolidifyConstants.URL_SEP
          + SolidifyConstants.URL_PARENT_ID + SolidifyConstants.URL_SEP + ResourceName.COMMENTS;

  public CommentClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(SolidifyClientApplication.getApplicationPrefix(), ModuleName.ADMIN, COMMENT_PATH, Comment.class, restClientTool, env);
  }

  @Override
  public List<Comment> findAll(String parentId) {
    return this.findAll(parentId, Comment.class);
  }

}
