package ch.unige.aou.service.admin;

import java.util.List;
import java.util.Map;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;

import ch.unige.solidify.SolidifyClientApplication;
import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.service.ResourceClientService;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.model.publication.Contributor;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;

@Service
public class ContributorClientService extends ResourceClientService<Contributor> {

  public ContributorClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(SolidifyClientApplication.getApplicationPrefix(), ModuleName.ADMIN, SolidifyConstants.URL_SEP + ResourceName.CONTRIBUTORS,
            Contributor.class,
            restClientTool, env);
  }

  @Override
  public List<Contributor> findAll() {
    return super.findAll(Contributor.class);
  }

  @Override
  public List<Contributor> searchByProperties(Map<String, String> properties) {
    return super.searchByProperties(properties, Contributor.class);
  }
}
