package ch.unige.aou.service.admin;

import java.util.List;
import java.util.Map;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;

import ch.unige.solidify.SolidifyClientApplication;
import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.service.ResourceClientService;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.model.publication.DocumentFile;
import ch.unige.aou.rest.AouActionName;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;

@Service
public class DocumentFileClientService extends ResourceClientService<DocumentFile> {

  public DocumentFileClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(SolidifyClientApplication.getApplicationPrefix(), ModuleName.ADMIN, SolidifyConstants.URL_SEP + ResourceName.DOCUMENT_FILES,
            DocumentFile.class,
            restClientTool, env);
  }

  public String fulltext(String documentFileId) {
    String url = this.getResourceUrl() + "/" + documentFileId + "/" + AouActionName.FULLTEXT;
    return this.restClientTool.getClient().getForObject(url, String.class);
  }

  @Override
  public List<DocumentFile> findAll() {
    return this.findAll(DocumentFile.class);
  }

  @Override
  public List<DocumentFile> searchByProperties(Map<String, String> properties) {
    return this.searchByProperties(properties, DocumentFile.class);
  }

}
