package ch.unige.aou.service.admin;

import java.util.List;
import java.util.Map;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;

import ch.unige.solidify.SolidifyClientApplication;
import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.service.ResourceClientService;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.model.publication.DocumentFileType;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;

@Service
public class DocumentFileTypeClientService extends ResourceClientService<DocumentFileType> {

  public DocumentFileTypeClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(SolidifyClientApplication.getApplicationPrefix(), ModuleName.ADMIN, SolidifyConstants.URL_SEP + ResourceName.DOCUMENT_FILE_TYPES,
            DocumentFileType.class, restClientTool, env);
  }

  @Override
  public List<DocumentFileType> findAll() {
    return this.findAll(DocumentFileType.class);
  }

  @Override
  public List<DocumentFileType> searchByProperties(Map<String, String> properties) {
    return this.searchByProperties(properties, DocumentFileType.class);
  }
}
