package ch.unige.aou.service.admin;

import java.util.List;
import java.util.Map;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import ch.unige.solidify.SolidifyClientApplication;
import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.model.GlobalBanner;
import ch.unige.solidify.service.ResourceClientService;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.rest.AouActionName;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;

@Service
public class GlobalBannerClientService extends ResourceClientService<GlobalBanner> {

  public GlobalBannerClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(SolidifyClientApplication.getApplicationPrefix(), ModuleName.ADMIN, SolidifyConstants.URL_SEP + ResourceName.GLOBAL_BANNERS,
            GlobalBanner.class,
            restClientTool, env);
  }

  public GlobalBanner getActive() {
    final String url = this.getResourceUrl() + SolidifyConstants.URL_SEP + AouActionName.GET_ACTIVE;
    final RestTemplate restTemplate = this.restClientTool.getClient();
    return restTemplate.getForObject(url, GlobalBanner.class);
  }

  @Override
  public List<GlobalBanner> findAll() {
    return this.findAll(GlobalBanner.class);
  }

  @Override
  public List<GlobalBanner> searchByProperties(Map<String, String> properties) {
    return this.searchByProperties(properties, GlobalBanner.class);
  }
}
