package ch.unige.aou.service.admin;

import java.util.List;
import java.util.Map;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import ch.unige.solidify.SolidifyClientApplication;
import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.rest.RestCollectionPage;
import ch.unige.solidify.service.ResourceClientService;
import ch.unige.solidify.util.AbstractRestClientTool;
import ch.unige.solidify.util.CollectionTool;

import ch.unige.aou.model.settings.LabeledLanguage;
import ch.unige.aou.model.settings.LanguageDTO;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;

@Service
public class LanguageClientService extends ResourceClientService<LabeledLanguage> {

  public LanguageClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(SolidifyClientApplication.getApplicationPrefix(), ModuleName.ADMIN, SolidifyConstants.URL_SEP + ResourceName.LANGUAGES,
            LabeledLanguage.class,
            restClientTool, env);
  }

  public List<LanguageDTO> listAll() {
    final String url = this.getResourceUrl() + "?size=" + RestCollectionPage.MAX_SIZE_PAGE;
    final RestTemplate restTemplate = this.restClientTool.getClient();
    final String jsonString = restTemplate.getForObject(url, String.class);
    return CollectionTool.getList(jsonString, LanguageDTO.class);
  }

  @Override
  public List<LabeledLanguage> findAll() {
    return super.findAll(LabeledLanguage.class);
  }

  @Override
  public List<LabeledLanguage> searchByProperties(Map<String, String> properties) {
    return super.searchByProperties(properties, LabeledLanguage.class);
  }
}
