package ch.unige.aou.service.admin;

import java.util.List;
import java.util.Map;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;

import ch.unige.solidify.SolidifyClientApplication;
import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.service.ResourceClientService;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.model.settings.License;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;

@Service
public class LicenseClientService extends ResourceClientService<License> {

  public LicenseClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(SolidifyClientApplication.getApplicationPrefix(), ModuleName.ADMIN, SolidifyConstants.URL_SEP + ResourceName.LICENSES, License.class,
            restClientTool, env);
  }

  @Override
  public List<License> findAll() {
    return this.findAll(License.class);
  }

  @Override
  public List<License> searchByProperties(Map<String, String> properties) {
    return this.searchByProperties(properties, License.class);
  }
}
