package ch.unige.aou.service.admin;

import java.util.List;
import java.util.Map;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import ch.unige.solidify.SolidifyClientApplication;
import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.service.ResourceClientService;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.model.notification.NotificationType;
import ch.unige.aou.rest.AouActionName;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;

@Service
public class NotificationTypeClientService extends ResourceClientService<NotificationType> {

  private static final String NOTIFICATION_TYPES_PATH = SolidifyConstants.URL_SEP + ResourceName.NOTIFICATION_TYPES;

  public NotificationTypeClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(SolidifyClientApplication.getApplicationPrefix(), ModuleName.ADMIN, NOTIFICATION_TYPES_PATH, NotificationType.class, restClientTool,
            env);
  }

  public List<String> getListNotificationsTypesMandatory() {
    final String url = this.getResourceUrl() + SolidifyConstants.URL_SEP + AouActionName.LIST_NOTIFICATIONS_TYPES_MANDATORY;
    final RestTemplate restTemplate = this.restClientTool.getClient();
    return restTemplate.getForObject(url, List.class);
  }

  @Override
  public List<NotificationType> findAll() {
    return null;
  }

  @Override
  public List<NotificationType> searchByProperties(Map<String, String> properties) {
    return null;
  }
}
