package ch.unige.aou.service.admin;

import java.util.List;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;

import ch.unige.solidify.SolidifyClientApplication;
import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.service.CompositionResourceClientService;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.model.publication.PublicationSubSubtype;
import ch.unige.aou.model.publication.PublicationSubtype;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;

@Service
public class PublicationSubSubtypeClientService extends CompositionResourceClientService<PublicationSubtype, PublicationSubSubtype> {

  private static final String PUBLICATION_SUB_SUBTYPES_PATH = SolidifyConstants.URL_SEP + ResourceName.PUBLICATION_SUBTYPES
          + SolidifyConstants.URL_PARENT_ID + ResourceName.PUBLICATION_SUB_SUBTYPES;

  public PublicationSubSubtypeClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(SolidifyClientApplication.getApplicationPrefix(), ModuleName.ADMIN, PUBLICATION_SUB_SUBTYPES_PATH, PublicationSubSubtype.class,
            restClientTool, env);
  }

  @Override
  public List<PublicationSubSubtype> findAll(String parentId) {
    return this.findAll(parentId, PublicationSubSubtype.class);
  }

}
