package ch.unige.aou.service.admin;

import java.util.List;
import java.util.Map;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;

import ch.unige.solidify.SolidifyClientApplication;
import ch.unige.solidify.rest.RestCollectionPage;
import ch.unige.solidify.service.ResourceClientService;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.model.search.StoredSearch;
import ch.unige.aou.rest.AouActionName;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;

@Service
public class StoredSearchClientService extends ResourceClientService<StoredSearch> {

  public StoredSearchClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(SolidifyClientApplication.getApplicationPrefix(), ModuleName.ADMIN, "/" + ResourceName.STORED_SEARCHES, StoredSearch.class,
            restClientTool, env);
  }

  public List<StoredSearch> listMySearches(Map<String, String> params) {
    String url = this.getResourceUrl() + "/" + AouActionName.LIST_MY_STORED_SEARCHES + "?size=" + RestCollectionPage.MAX_SIZE_PAGE;
    return this.searchByProperties(url, params, StoredSearch.class);
  }

  @Override
  public List<StoredSearch> findAll() {
    return super.findAll(StoredSearch.class);
  }

  @Override
  public List<StoredSearch> searchByProperties(Map<String, String> properties) {
    return super.searchByProperties(properties, StoredSearch.class);
  }

}
