package ch.unige.aou.service.admin;

import java.util.List;
import java.util.Map;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;

import ch.unige.solidify.SolidifyClientApplication;
import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.service.ResourceClientService;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.model.security.User;
import ch.unige.aou.rest.AouActionName;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;

@Service
public class UserClientService extends ResourceClientService<User> {

  private static final String USER_PATH = SolidifyConstants.URL_SEP + ResourceName.USERS;

  /********************************/

  public UserClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(SolidifyClientApplication.getApplicationPrefix(), ModuleName.ADMIN, USER_PATH, User.class, restClientTool, env);
  }

  /********************************/

  public User getAuthenticatedUser() {
    return this.doAction(AouActionName.AUTHENTICATED);
  }

  @Override
  public List<User> findAll() {
    return this.findAll(User.class);
  }

  @Override
  public List<User> searchByProperties(Map<String, String> properties) {
    return this.searchByProperties(properties, User.class);
  }

}
