package ch.unige.aou.test.admin;

import static org.junit.jupiter.api.Assertions.assertDoesNotThrow;
import static org.junit.jupiter.api.Assertions.assertNotNull;
import static org.junit.jupiter.api.Assertions.assertTrue;

import java.io.IOException;

import org.junit.jupiter.api.Test;
import org.springframework.core.io.ClassPathResource;

import ch.unige.aou.model.publication.DocumentFile;
import ch.unige.aou.model.publication.Publication;

class DocumentFileAsRootIT extends AbstractDocumentFileIT {

  @Override
  protected void setUser() {
    this.restClientTool.sudoRoot();
  }

  @Test
  void testGetFulltext() throws IOException {
    Publication publication = this.createPublicationFixture(this.getTemporaryTestLabel("Publication to create document"));
    DocumentFile documentFile = this.uploadDocumentFile(publication, new ClassPathResource(TEST_FILE_TO_UPLOAD));
    assertNotNull(documentFile);

    String documentFileResId = documentFile.getResId();
    String text = assertDoesNotThrow(() -> this.documentFileService.fulltext(documentFileResId));
    assertTrue(text.contains("Lorem ipsum dolor  sit  amet,  consectetur  adipisicing elit"));

    // try a second time to test cache
    text = assertDoesNotThrow(() -> this.documentFileService.fulltext(documentFileResId));
    assertTrue(text.contains("Lorem ipsum dolor  sit  amet,  consectetur  adipisicing elit"));
  }
}
