package ch.unige.aou.test.admin;

import java.time.OffsetDateTime;
import java.util.List;
import java.util.stream.Collectors;

import org.junit.jupiter.api.Test;

import ch.unige.solidify.model.GlobalBanner;

class GlobalBannerAsUserIT extends GlobalBannerIT {

  @Override
  protected void setUser() {
    this.restClientTool.sudoUser();
  }

  @Test
  void getActive() {
    this.restClientTool.sudoRoot();
    List<GlobalBanner> listGlobalBanner = this.globalBannerService.findAll();

    OffsetDateTime now = OffsetDateTime.now();

    List<GlobalBanner> listMatchingGlobalBanner = listGlobalBanner.stream().filter(globalBanner ->
            globalBanner.getEnabled()
                    && globalBanner.getStartDate().isBefore(now)
                    && globalBanner.getEndDate().isAfter(now)
    ).collect(Collectors.toList());
    this.restClientTool.exitSudo();

    GlobalBanner expectedActiveGlobalBanner = null;
    if (listMatchingGlobalBanner.size() == 0) {
      // If no banner is already active create a temporary banner
      expectedActiveGlobalBanner = this.createTestGlobalBanner("Active banner", GlobalBanner.GlobalBannerType.CRITICAL, true,
              now.minusMinutes(2), now.plusMinutes(2));
    } else {
      expectedActiveGlobalBanner = listMatchingGlobalBanner.get(0);
    }

    GlobalBanner activeGlobalBanner = this.globalBannerService.getActive();
    this.assertsGlobalBanner(expectedActiveGlobalBanner, activeGlobalBanner);
  }
}
