package ch.unige.aou.test.admin;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertThrows;

import org.junit.jupiter.api.Test;
import org.springframework.http.HttpStatus;
import org.springframework.web.client.HttpClientErrorException;

import ch.unige.solidify.auth.model.AuthApplicationRole;

import ch.unige.aou.model.security.User;

class UserAsUserIT extends AbstractAdminIT {

  @Test
  void userCannotCreateUser() {
    User user = new User();
    HttpClientErrorException e = assertThrows(HttpClientErrorException.class, () -> {
      this.userService.create(user);
    });
    assertEquals(HttpStatus.FORBIDDEN, e.getStatusCode());
  }

  @Test
  void userCannotUpdateUser() {
    this.restClientTool.sudoRoot();
    User user = this.getUserWithRole(AuthApplicationRole.USER);
    this.restClientTool.exitSudo();
    user.setLastName("Grogou");
    String userId = user.getResId();
    HttpClientErrorException e = assertThrows(HttpClientErrorException.class, () -> {
      this.userService.update(userId, user);
    });
    assertEquals(HttpStatus.FORBIDDEN, e.getStatusCode());
  }

  @Test
  void userCannotDeleteUser() {
    this.restClientTool.sudoRoot();
    User user = this.getUserWithRole(AuthApplicationRole.USER);
    this.restClientTool.exitSudo();
    String userId = user.getResId();
    HttpClientErrorException e = assertThrows(HttpClientErrorException.class, () -> {
      this.userService.delete(userId);
    });
    assertEquals(HttpStatus.FORBIDDEN, e.getStatusCode());
  }

  @Override
  protected void deleteFixtures() {
    // Do nothing
  }
}
