package ch.unige.aou.model.display;

import java.util.ArrayList;
import java.util.List;

import ch.unige.solidify.rest.ResourceBase;
import ch.unige.solidify.util.ReflectionTool;

import ch.unige.aou.model.publication.PublicationSubtype;
import ch.unige.aou.model.settings.Structure;

/**
 * Class used to return validation rights in Json response for a person
 */
public class StructureValidationRight extends Structure {

  private final List<PublicationSubtype> publicationSubtypes = new ArrayList<>();

  public StructureValidationRight() {
    // empty constructor useful for Json deserialization
  }

  public StructureValidationRight(Structure structure) {
    ReflectionTool.copyFields(this, structure, ResourceBase.class);
  }

  public boolean addPublicationSubtypes(List<PublicationSubtype> publicationSubtypes) {
    return this.publicationSubtypes.addAll(publicationSubtypes);
  }

  public List<PublicationSubtype> getPublicationSubtypes() {
    return this.publicationSubtypes;
  }
}
