package ch.unige.aou.model.publication;

public enum DateType {
  PUBLICATION("publication"),
  FIRST_ONLINE("first_online"),
  IMPRIMATUR("imprimatur"),
  DEFENSE("defense");

  private final String metadataValue;

  DateType(String metadataValue) {
    this.metadataValue = metadataValue;
  }

  public String metadataValue() {
    return this.metadataValue;
  }

  public static DateType fromMetadataValue(String metadataValue) {
    for (DateType dateType : DateType.values()) {
      if (dateType.metadataValue.equals(metadataValue)) {
        return dateType;
      }
    }
    throw new IllegalArgumentException(metadataValue);
  }
}
