package ch.unige.aou.model.publication;

import java.util.ArrayList;
import java.util.List;
import javax.persistence.CollectionTable;
import javax.persistence.Column;
import javax.persistence.ElementCollection;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.UniqueConstraint;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import ch.unige.aou.AouConstants;
import ch.unige.aou.model.AouResourceNormalized;
import ch.unige.aou.model.settings.Label;

@Entity
public class DocumentFileType extends AouResourceNormalized {
  
  public enum FileTypeLevel {
    PRINCIPAL,      // Article, Book, Thesis, ...
    SECONDARY,      // Appendix, Supplemental data, Translation, ...
    CORRECTIVE,     // Erratum, Corrigendum, ...
    ADMINISTRATION  // Agreement, ...
  }

  @OneToMany(mappedBy = PublicationSubtypeDocumentFileType.PATH_TO_DOCUMENT_FILE_TYPE)
  private List<PublicationSubtypeDocumentFileType> publicationSubtypeDocumentFileTypes;

  @Size(min = 1)
  @NotNull
  @Column(unique = true)
  private String value;

  @ElementCollection
  @Column(name = AouConstants.DB_DOCUMENT_FILE_TYPE_ID)
  @CollectionTable(joinColumns = { @JoinColumn(name = AouConstants.DB_DOCUMENT_FILE_TYPE_ID) },
                   uniqueConstraints = @UniqueConstraint(columnNames = { AouConstants.DB_DOCUMENT_FILE_TYPE_ID, AouConstants.DB_LANGUAGE_ID }))
  private List<Label> labels = new ArrayList<>();

  /****************************************************************/

  public String getValue() {
    return this.value;
  }

  public void setValue(String value) {
    this.value = value;
  }

  public List<Label> getLabels() {
    return this.labels;
  }

  public void setLabels(List<Label> labels) {
    this.labels = labels;
  }
}
