package ch.unige.aou.model.publication;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import ch.unige.aou.model.settings.Label;
import ch.unige.aou.model.settings.LabelDTO;

public class PublicationSubtypeDTO implements Serializable {

  private String resId;
  private String name;
  private String code;
  private PublicationTypeDTO type;
  private List<LabelDTO> labels = new ArrayList<>();

  public PublicationSubtypeDTO() {
  }

  public PublicationSubtypeDTO(PublicationSubtype subtype) {
    if (subtype != null) {
      this.setResId(subtype.getResId());
      this.setCode(subtype.getCode());
      this.setName(subtype.getName());
      this.setType(new PublicationTypeDTO(subtype.getPublicationType()));
      for (Label label : subtype.getLabels()) {
        LabelDTO labelDTO = new LabelDTO();
        labelDTO.setText(label.getText());
        labelDTO.setLanguageCode(label.getLanguageCode());
        this.labels.add(labelDTO);
      }
    }
  }

  public String getResId() {
    return this.resId;
  }

  public void setResId(String resId) {
    this.resId = resId;
  }

  public String getName() {
    return this.name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public String getCode() {
    return this.code;
  }

  public void setCode(String code) {
    this.code = code;
  }

  public PublicationTypeDTO getType() {
    return this.type;
  }

  public void setType(PublicationTypeDTO publicationType) {
    this.type = publicationType;
  }

  public List<LabelDTO> getLabels() {
    return this.labels;
  }

  public void setLabels(List<LabelDTO> labels) {
    this.labels = labels;
  }
}
