package ch.unige.aou.model.publication;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import ch.unige.aou.model.settings.Label;

public class PublicationSubtypeDocumentFileTypeDTO implements Serializable {

  private DocumentFileType.FileTypeLevel level;
  private int sortValue;
  private String value;
  private String documentFileTypeId;
  private String publicationSubtypeId;
  private List<Label> labels = new ArrayList<>();

  public PublicationSubtypeDocumentFileTypeDTO() {
  }

  public PublicationSubtypeDocumentFileTypeDTO(PublicationSubtypeDocumentFileType subtypeDocFile) {
    this.level = subtypeDocFile.getLevel();
    this.sortValue = subtypeDocFile.getSortValue();

    if (subtypeDocFile.getDocumentFileType() != null) {
      this.value = subtypeDocFile.getDocumentFileType().getValue();
      this.labels.addAll(subtypeDocFile.getDocumentFileType().getLabels());
    }

    if (subtypeDocFile.getDocumentFileType() != null) {
      this.documentFileTypeId = subtypeDocFile.getDocumentFileType().getResId();
    }

    if (subtypeDocFile.getPublicationSubtype() != null) {
      this.publicationSubtypeId = subtypeDocFile.getPublicationSubtype().getResId();
    }
  }

  public DocumentFileType.FileTypeLevel getLevel() {
    return this.level;
  }

  public String getValue() {
    return this.value;
  }

  public int getSortValue() {
    return this.sortValue;
  }

  public String getPublicationSubtypeId() {
    return this.publicationSubtypeId;
  }

  public List<Label> getLabels() {
    return this.labels;
  }

  public String getDocumentFileTypeId() {
    return this.documentFileTypeId;
  }
}
