package ch.unige.aou.model.search;

import java.util.ArrayList;
import java.util.List;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import ch.unige.solidify.SolidifyConstants;

import ch.unige.aou.AouConstants;
import ch.unige.aou.model.AouResourceNormalized;
import ch.unige.aou.model.settings.Person;

@Entity
@Table(uniqueConstraints = { @UniqueConstraint(columnNames = { AouConstants.DB_CREATOR_ID, AouConstants.DB_NAME }) })
public class StoredSearch extends AouResourceNormalized {

  @ManyToOne(targetEntity = Person.class)
  @JoinColumn(name = AouConstants.DB_CREATOR_ID, referencedColumnName = AouConstants.DB_RES_ID, nullable = false)
  private Person creator;

  @NotNull
  @Size(min = 1, max = SolidifyConstants.DB_DEFAULT_STRING_LENGTH)
  @Column(name = AouConstants.DB_NAME)
  private String name;

  @OneToMany(mappedBy = "search", cascade = CascadeType.ALL, orphanRemoval = true)
  private List<StoredSearchCriteria> criteria = new ArrayList<>();

  /****************************************************************/

  public Person getCreator() {
    return this.creator;
  }

  public void setCreator(Person creator) {
    this.creator = creator;
  }

  public String getName() {
    return this.name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public List<StoredSearchCriteria> getCriteria() {
    return this.criteria;
  }
}
