package ch.unige.aou.model.xml.deposit.v1.serializer;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;

import ch.unige.aou.model.xml.deposit.v1.Link;
import ch.unige.aou.model.xml.deposit.v1.Links;

public class LinksSerializer extends StdSerializer<Links> {
  public LinksSerializer() {
    this(null);
  }

  public LinksSerializer(Class<Links> t) {
    super(t);
  }

  @Override
  public void serialize(Links value, JsonGenerator jgen, SerializerProvider provider) throws IOException, JsonProcessingException {
    jgen.writeStartArray();
    for (Link link : value.getLink()) {
      jgen.writeStartObject();
      jgen.writeStringField("target", link.getTarget());
      jgen.writeStringField("type", link.getType().value());
      jgen.writeObjectField("description", link.getDescription());
      jgen.writeEndObject();
    }
    jgen.writeEndArray();
  }
}
