package ch.unige.aou.model.xml.deposit.v2_2.deserializer;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.ObjectCodec;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ArrayNode;

import ch.unige.solidify.exception.SolidifyRuntimeException;

import ch.unige.aou.model.xml.deposit.AouStdDeserializer;
import ch.unige.aou.model.xml.deposit.v2_2.AcademicStructure;
import ch.unige.aou.model.xml.deposit.v2_2.AcademicStructures;

public class AcademicsStructuresDeserializer extends AouStdDeserializer<AcademicStructures> {

  private static final long serialVersionUID = 659865L;

  @Override
  public AcademicStructures deserialize(JsonParser parser, DeserializationContext context) throws IOException, JsonProcessingException {

    ObjectCodec codec = parser.getCodec();
    JsonNode jsonNode = codec.readTree(parser);

    if (jsonNode instanceof ArrayNode) {
      if (jsonNode.isEmpty()) {
        return null;
      }

      AcademicStructures academicStructures = new AcademicStructures();

      jsonNode.forEach(structureNode -> {
        AcademicStructure structure = new AcademicStructure();
        if (this.nodeHasTextValue(structureNode)) {
          structure.setResId(structureNode.textValue());
        }
        academicStructures.getAcademicStructure().add(structure);
      });

      return academicStructures;

    } else {
      throw new SolidifyRuntimeException("academicStructures is not an array");
    }
  }
}
