package ch.unige.aou.model.xml.deposit.v2_2.serializer;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;

import ch.unige.solidify.util.StringTool;

import ch.unige.aou.model.xml.deposit.v2_2.Correction;
import ch.unige.aou.model.xml.deposit.v2_2.Corrections;

public class CorrectionsSerializer extends StdSerializer<Corrections> {
  public CorrectionsSerializer() {
    this(null);
  }

  public CorrectionsSerializer(Class<Corrections> t) {
    super(t);
  }

  @Override
  public void serialize(Corrections value, JsonGenerator jgen, SerializerProvider provider) throws IOException, JsonProcessingException {
    jgen.writeStartArray();
    for (Correction correction : value.getCorrection()) {
      jgen.writeStartObject();
      jgen.writeStringField("note", correction.getNote());
      if (!StringTool.isNullOrEmpty(correction.getDoi())) {
        jgen.writeObjectField("doi", correction.getDoi());
      }
      if (!StringTool.isNullOrEmpty(correction.getPmid())) {
        jgen.writeObjectField("pmid", correction.getPmid());
      }
      jgen.writeEndObject();
    }
    jgen.writeEndArray();
  }
}
