package ch.unige.aou.model.xml.deposit.v2_3.deserializer;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.ObjectCodec;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonNode;

import ch.unige.aou.model.xml.deposit.AouStdDeserializer;
import ch.unige.aou.model.xml.deposit.v2_3.TextLang;

/**
 * Parse a TextLang which is a text with a mandatory lang
 */
public class TextLangDeserializer extends AouStdDeserializer<TextLang> {

  private static final long serialVersionUID = 2843139899413104666L;

  @Override
  public TextLang deserialize(JsonParser parser, DeserializationContext context) throws IOException, JsonProcessingException {

    ObjectCodec codec = parser.getCodec();
    JsonNode jsonNode = codec.readTree(parser);

    JsonNode textNode = jsonNode.get("text");
    JsonNode langNode = jsonNode.get("lang");

    TextLang textLang = new TextLang();

    boolean hasValue = false;

    if (this.nodeHasTextValue(textNode)) {
      textLang.setContent(textNode.textValue());
      hasValue = true;
    }

    if (this.nodeHasTextValue(langNode)) {
      textLang.setLang(langNode.textValue());
      hasValue = true;
    }

    if (hasValue) {
      return textLang;
    } else {
      return null;
    }
  }
}
