package ch.unige.aou.model.xml.deposit.v2_4.serializer;

import java.io.IOException;
import java.io.Serializable;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;

import ch.unige.aou.model.xml.deposit.v2_4.Collaboration;
import ch.unige.aou.model.xml.deposit.v2_4.Contributor;
import ch.unige.aou.model.xml.deposit.v2_4.Contributors;

public class ContributorsSerializer extends StdSerializer<Contributors> {
  public ContributorsSerializer() {
    this(null);
  }

  public ContributorsSerializer(Class<Contributors> t) {
    super(t);
  }

  @Override
  public void serialize(Contributors value, JsonGenerator jgen, SerializerProvider provider) throws IOException, JsonProcessingException {
    jgen.writeStartArray();
    for (Serializable serializable : value.getContributorOrCollaboration()) {
      jgen.writeStartObject();
      if (serializable instanceof Contributor) {
        jgen.writeObjectField("contributor", serializable);
      } else if (serializable instanceof Collaboration) {
        jgen.writeObjectField("collaboration", serializable);
      }
      jgen.writeEndObject();
    }
    jgen.writeEndArray();
  }
}
