package ch.unige.aou.specification;

import java.util.List;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.unige.solidify.specification.SolidifySpecification;

import ch.unige.aou.model.publication.Contributor;

public class ContributorSpecification extends SolidifySpecification<Contributor> {

  public ContributorSpecification(Contributor criteria) {
    super(criteria);
  }

  @Override
  protected void completePredicatesList(Root<Contributor> root, CriteriaQuery<?> query, CriteriaBuilder builder,
          List<Predicate> predicatesList) {
    if (this.criteria.getCnIndividu() != null) {
      predicatesList.add(builder.equal(root.get("cnIndividu"), this.criteria.getCnIndividu()));
    }
    if (this.criteria.getFirstName() != null) {
      predicatesList.add(builder.like(root.get("firstName"), "%" + this.criteria.getFirstName() + "%"));
    }
    if (this.criteria.getLastName() != null) {
      predicatesList.add(builder.like(root.get("lastName"), "%" + this.criteria.getLastName() + "%"));
    }
  }
}
