package ch.unige.aou.specification;

import java.util.List;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.JoinType;
import javax.persistence.criteria.Path;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.unige.aou.AouConstants;
import ch.unige.aou.model.publication.Publication;
import ch.unige.aou.model.settings.Person;

public class PublicationContributorSpecification extends PublicationSpecification {

  private final String cnIndividu;

  public PublicationContributorSpecification(Publication criteria, String cnIndividu) {
    super(criteria);
    this.cnIndividu = cnIndividu;
  }

  @Override
  protected void completePredicatesList(Root<Publication> root, CriteriaQuery<?> query, CriteriaBuilder builder,
          List<Predicate> predicatesList) {

    super.completePredicatesList(root, query, builder, predicatesList);

    Path<Person> contributorPath = root.join("contributors", JoinType.LEFT).get(AouConstants.DB_CN_INDIVIDU);
    Predicate equalContributor = builder.equal(contributorPath, this.cnIndividu);

    //Get Publications that contain the cnIndividu in its contributors
    predicatesList.add(equalContributor);

    query.distinct(true);
  }
}
