package ch.unige.aou.specification;

import java.util.List;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.unige.solidify.specification.SolidifySpecification;

import ch.unige.aou.model.search.StoredSearch;

public class StoredSearchSpecification extends SolidifySpecification<StoredSearch> {
  private static final long serialVersionUID = 8669419110874167742L;

  public StoredSearchSpecification(StoredSearch criteria) {
    super(criteria);
  }

  @Override
  protected void completePredicatesList(Root<StoredSearch> root, CriteriaQuery<?> query, CriteriaBuilder builder,
          List<Predicate> predicatesList) {
    if (this.criteria.getCreator() != null) {
      predicatesList.add(builder.equal(root.get("creator").get("resId"), this.criteria.getCreator().getResId()));
    }
    if (this.criteria.getName() != null) {
      predicatesList.add(builder.like(root.get("name"), "%" + this.criteria.getName() + "%"));
    }
  }
}
