package ch.unige.aou.repository;

import java.time.OffsetDateTime;
import java.util.List;

import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import ch.unige.solidify.repository.SolidifyRepository;

import ch.unige.aou.model.settings.DownloadToken;

@Repository
public interface DownloadTokenRepository extends SolidifyRepository<ch.unige.aou.model.settings.DownloadToken> {

  DownloadToken findByTokenHash(String tokenHash);

  DownloadToken findByArchiveIdAndUserId(String archiveId, String userId);

  @Query("SELECT DISTINCT d FROM DownloadToken d WHERE d.creation.when < :limitTime")
  List<DownloadToken> findExpiredDownloadTokens(OffsetDateTime limitTime);
}
