package ch.unige.aou.service.index.elasticsearch;

import org.springframework.context.annotation.Profile;
import org.springframework.stereotype.Service;

import ch.unige.solidify.IndexProperties;
import ch.unige.solidify.index.ElasticsearchClientProvider;
import ch.unige.solidify.index.indexing.elasticsearch.ElasticsearchService;

import ch.unige.aou.model.index.PublicationIndexEntry;

@Profile("index-elasticsearch")
@Service
public class PublicationIndexingService extends ElasticsearchService<PublicationIndexEntry> {
  public PublicationIndexingService(
          IndexProperties indexProperties,
          ElasticsearchClientProvider elasticsearchClientProvider) {
    super(indexProperties, elasticsearchClientProvider);
  }

  @Override
  public String getIndexName(String indexName) {
    return indexName;
  }

  @Override
  protected PublicationIndexEntry getMetadataObject() {
    return new PublicationIndexEntry();
  }
}
