package ch.unige.aou.service.index.inmemory;

import org.springframework.context.annotation.Profile;
import org.springframework.stereotype.Service;

import ch.unige.solidify.IndexProperties;
import ch.unige.solidify.index.indexing.inmemory.InMemoryService;
import ch.unige.solidify.index.indexing.inmemory.IndexData;
import ch.unige.solidify.index.settings.inmemory.InMemorySettingsService;

import ch.unige.aou.config.AouProperties;
import ch.unige.aou.model.index.PublicationIndexEntry;

@Profile("index-inmemory")
@Service
public class InMemoryPublicationIndexingService extends InMemoryService<PublicationIndexEntry> {
  public InMemoryPublicationIndexingService(AouProperties aouProperties, IndexProperties indexProperties,
          InMemorySettingsService settingsService, IndexData indexData) {
    super(indexProperties, settingsService, aouProperties.getIndexing().getIndexDefinitionList(), indexData);
  }

  @Override
  public String getIndexName(String indexName) {
    return indexName;
  }

  @Override
  protected PublicationIndexEntry getMetadataObject() {
    return new PublicationIndexEntry();
  }
}
