package ch.unige.aou.service.rest.abstractservice;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.domain.Pageable;

import ch.unige.solidify.rest.RestCollection;
import ch.unige.solidify.service.SolidifyRestClientService;

import ch.unige.aou.config.AouProperties;
import ch.unige.aou.model.publication.DocumentFileType;
import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.service.AouCacheNames;

public abstract class DocumentFileTypeRemoteResourceService extends AdminRemoteResourceService<DocumentFileType> {

  protected DocumentFileTypeRemoteResourceService(SolidifyRestClientService restClientService, AouProperties aouProperties) {
    super(restClientService, aouProperties);
  }

  @Cacheable(AouCacheNames.DOCUMENT_FILE_TYPES)
  public RestCollection<DocumentFileType> findAllWithCache(Pageable pageable) {
    return super.findAll(pageable);
  }

  @Override
  protected Class<DocumentFileType> getResourceClass() {
    return DocumentFileType.class;
  }

  @Override
  protected String getResourceUrl() {
    return this.adminModuleUrl + "/" + ResourceName.DOCUMENT_FILE_TYPES;
  }
}
