package ch.unige.aou.service.rest.abstractservice;

import java.util.List;

import org.springframework.cache.annotation.Cacheable;

import ch.unige.solidify.model.index.IndexFieldAlias;
import ch.unige.solidify.rest.FacetRequest;
import ch.unige.solidify.service.SolidifyRestClientService;

import ch.unige.aou.config.AouProperties;
import ch.unige.aou.rest.AouActionName;
import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.service.AouCacheNames;

public abstract class IndexPropertiesRemoteResourceService extends DataMgmtRemoteResourceService<IndexFieldAlias> {

  protected IndexPropertiesRemoteResourceService(SolidifyRestClientService restClientService, AouProperties aouProperties) {
    super(restClientService, aouProperties);
  }

  @Cacheable(AouCacheNames.FACET_REQUEST)
  public List<FacetRequest> getFacetRequests(String indexName) {
    String url = this.getResourceUrl() + "/" + AouActionName.LIST_FACET_REQUESTS + "/" + indexName;
    return this.restClientService.getAllResources(url, FacetRequest.class);
  }

  @Cacheable(AouCacheNames.INDEX_FIELD_ALIAS)
  public List<IndexFieldAlias> getIndexFieldAliases(String indexName) {
    String url = this.getResourceUrl() + "/" + AouActionName.LIST_INDEX_FIELD_ALIASES + "/" + indexName;
    return this.restClientService.getAllResources(url, IndexFieldAlias.class);
  }

  @Override
  protected Class<IndexFieldAlias> getResourceClass() {
    return IndexFieldAlias.class;
  }

  @Override
  protected String getResourceUrl() {
    return this.dataMgmtModuleUrl + "/" + ResourceName.INDEX_PROPERTIES;
  }
}
