package ch.unige.aou.service.rest.abstractservice;

import java.util.List;

import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;

import ch.unige.solidify.rest.RestCollection;
import ch.unige.solidify.rest.RestCollectionPage;
import ch.unige.solidify.service.SolidifyRestClientService;

import ch.unige.aou.AouConstants;
import ch.unige.aou.config.AouProperties;
import ch.unige.aou.model.StatusHistory;
import ch.unige.aou.model.publication.Publication;
import ch.unige.aou.rest.ResourceName;

public abstract class PublicationRemoteResourceService extends AdminRemoteResourceService<Publication> {

  protected PublicationRemoteResourceService(SolidifyRestClientService restClientService, AouProperties aouProperties) {
    super(restClientService, aouProperties);
  }

  public List<StatusHistory> history(String resId) {
    final Pageable page = PageRequest.of(0, RestCollectionPage.MAX_SIZE_PAGE, Sort.by(AouConstants.CHANGE_TIME));
    // Build URL
    String url = this.getResourceUrl() + "/" + resId + "/" + ResourceName.HISTORY;
    RestCollection<StatusHistory> statusHistoryRestCollection = this.restClientService.getResourceList(url, StatusHistory.class, page);
    return statusHistoryRestCollection.getData();
  }

  @Override
  protected Class<Publication> getResourceClass() {
    return Publication.class;
  }

  @Override
  protected String getResourceUrl() {
    return this.adminModuleUrl + "/" + ResourceName.PUBLICATIONS;
  }
}
