package ch.unige.aou.service.rest.abstractservice;

import java.util.ArrayList;
import java.util.List;

import org.springframework.cache.annotation.Cacheable;

import ch.unige.solidify.service.SolidifyRestClientService;

import ch.unige.aou.config.AouProperties;
import ch.unige.aou.model.settings.Structure;
import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.service.AouCacheNames;

public class StructureRemoteResourceService extends AdminRemoteResourceService<Structure> {

  protected StructureRemoteResourceService(SolidifyRestClientService restClientService, AouProperties aouProperties) {
    super(restClientService, aouProperties);
  }

  public Structure getParentStructure(String resId) {
    Structure structure = this.findOne(resId);
    if (structure.getParentStructure() != null) {
      return this.findOne(structure.getParentStructure().getResId());
    }
    return null;
  }

  @Cacheable(AouCacheNames.STRUCTURES)
  public List<String> getParentStructureIds(String resId) {
    Structure parentStructure = this.getParentStructure(resId);
    List<String> parentStructureIds = new ArrayList<>();
    while (parentStructure != null) {
      parentStructureIds.add(parentStructure.getResId());
      parentStructure = this.getParentStructure(parentStructure.getResId());
    }
    return parentStructureIds;
  }

  @Override
  protected Class<Structure> getResourceClass() {
    return Structure.class;
  }

  @Override
  protected String getResourceUrl() {
    return this.adminModuleUrl + "/" + ResourceName.STRUCTURES;
  }
}
