package ch.unige.aou.service.rest.trusted;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;

import ch.unige.solidify.auth.client.service.UserCreatorService;
import ch.unige.solidify.service.UserInfoService;

import ch.unige.aou.config.AouProperties;
import ch.unige.aou.rest.AouActionName;
import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.service.AouCacheNames;
import ch.unige.aou.service.rest.TrustedRestClientService;
import ch.unige.aou.service.rest.abstractservice.UserRemoteResourceService;

@Service
public class TrustedUserRemoteResourceService extends UserRemoteResourceService implements UserCreatorService, UserInfoService {

  public TrustedUserRemoteResourceService(TrustedRestClientService restClientService, AouProperties aouProperties) {
    super(restClientService, aouProperties);
  }

  @Override
  @Cacheable(AouCacheNames.NEW_USER)
  public String createNewUser(String externalUid) {
    final String url = this.adminModuleUrl + "/" + ResourceName.USERS + "/" + AouActionName.NEW_USER + "/" + externalUid;
    this.restClientService.postResourceAction(url);
    return externalUid;
  }
}
