package ch.unige.aou.test.doc;

import java.security.Principal;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;
import org.springframework.util.MultiValueMap;

import ch.unige.solidify.IndexDefinition;
import ch.unige.solidify.IndexDefinitionList;
import ch.unige.solidify.auth.client.service.AuthorizationClientProperties;
import ch.unige.solidify.service.HttpRequestInfoProvider;
import ch.unige.solidify.test.helper.AbstractResourceDoc;

import ch.unige.aou.config.AouProperties;

@Configuration
public class SolutionRestTestsAndDocumentationConfig {
  @Primary
  @Bean
  public HttpRequestInfoProvider httpRequestInfoProvider() {
    return new HttpRequestInfoProvider() {

      @Override
      public String getIncomingToken() {
        return "";
      }

      @Override
      public MultiValueMap<String, String> getAuthorizationHeader() {
        return null;
      }

      @Override
      public Principal getPrincipal() {
        return () -> "AOU_externalUid";
      }

    };
  }

  @Bean
  public AuthorizationClientProperties authorizationClientProperties() {
    AuthorizationClientProperties properties = new AuthorizationClientProperties();
    properties.setTrustedUserName("doc");
    properties.setTrustedUserPassword("doc");
    properties.setClientId("doc");
    properties.setClientSecret("doc");
    properties.setRedirectUri("doc");
    properties.setAuthorizationServerUrl("doc");
    properties.setApplicationName("doc");
    return properties;
  }

  @Primary
  @Bean
  public IndexDefinitionList indexDefinitionListForTests(AouProperties aouProperties) {
    IndexDefinitionList list = new IndexDefinitionList();
    list.getIndexList().add(new IndexDefinition(AbstractResourceDoc.TEST_STRING_VALUE, null));
    list.getIndexList()
            .add(new IndexDefinition(AbstractResourceDoc.TEST_STRING_VALUE + aouProperties.getIndexing().getPublishedPublicationsIndexName(),
                    null));
    list.getIndexList()
            .add(new IndexDefinition(AbstractResourceDoc.TEST_STRING_VALUE + aouProperties.getIndexing().getInProgressPublicationsIndexName(),
                    null));
    return list;
  }
}
