package ch.unige.aou.test.resource;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.springframework.restdocs.payload.FieldDescriptor;

import ch.unige.solidify.test.helper.AbstractResourceDoc;
import ch.unige.solidify.test.helper.FieldDescriptorBuilder;
import ch.unige.solidify.test.model.TypeField;

public class PublicationSubSubtypeDTODoc extends AbstractResourceDoc {

  @Override
  public List<String> getListLinks() {
    return Collections.emptyList();
  }

  @Override
  public String getName() {
    return "publication-sub-subtype-dto";
  }

  @Override
  public List<String> getResourceLinks() {
    return Collections.emptyList();
  }

  @Override
  protected List<FieldDescriptor> getDocumentationFields() {
    // @formatter:off
    final List<FieldDescriptor> documentationFields =  new ArrayList<>(Arrays.asList(
            new FieldDescriptorBuilder(this)
                    .name("subSubtype.resId")
                    .description("Id of the subSubtype")
                    .mandatory(true)
                    .type(TypeField.STRING)
                    .testValue("A1-EDITORIAL")
                    .build(),
            new FieldDescriptorBuilder(this)
                    .name("subSubtype.name")
                    .description("Name of the subSubtype")
                    .mandatory(true)
                    .type(TypeField.STRING)
                    .build()
    ));
    // @formatter:on
    documentationFields.addAll(new PublicationSubtypeDTODoc().getDocumentationFields("subSubtype"));
    return documentationFields;
  }
}
